#!/bin/bash
# Example showing correlations in sequence generated by not-so-good LCG parameters

n=30000
c=2

# ./random_LCG 65 65537 319

./random_LCG $1 $2 $3 $n | awk '{print $3}' > numbers.txt

tail -n +$c  numbers.txt > numbers2.txt

((n=n-c+1))
paste numbers.txt numbers2.txt | head -n $n > correlate.dat
# correlate contains pairs (x_n+1 , x_n ) when c=2
# correlate contains pairs (x_n+(c-1) , x_n ) in general

gnuplot <<!
#set terminal x11 enhanced font 'Verdana,20' persist
set terminal qt enhanced font 'Verdana,20' persist
set title  "Correlation: x_{n+1} vs x_n"
set key left top
set xlabel "x_n"
set ylabel "x_{n+1}"
set xrange [0:1]
set yrange [0:1]

plot "correlate.dat" using 1:2 notitle with dots
!
